procedure scansaostar(imlist, dwidth, st_log)

file    imlist          {prompt = "Input image"}
int     dwidth          {prompt = "Interval of sample"}
file    st_log          {prompt = "Log file of linepos"}


struct  *list5    {mode = 'h'}
#
#
begin
        string  openfile,logfile,comfile
        string  openfile1,openfile2
        string  tmpfile4, tmpfile5
        string  junk1, junk2, junk3, junk4, junk5, junk6, junk7
        string  dummy1,dummy2

        int     naxis1,naxis2 
        int     i, nselect, npoint
        int     tx1, tx2
	int	pixwid
        real    x, y, x_pos, y_pos, y_sigma, peakvalue
        real    x_end, y_end
        string  wcs
        struct  command
        string  key

        openfile = imlist
        openfile1 = imlist+"[1:512,*]"
        openfile2 = imlist+"[513:1024,*]"
        logfile = st_log
        pixwid = dwidth

        junk1=""
        junk2=""
        junk3=""
        junk4=""
        junk5=""
        junk6=""
        junk7=""

        list5 = ""
        tmpfile4  = mktemp( "tmp_file." )
        tmpfile5  = mktemp( "tmp_file." )

        print( "Measure a spectrum's position using IMEXAM." )

        print( "Move cursor to the spectrum" )
        print( " and push   "  )
        print( "           k to measure " ) 
        print( "           q to finish a mesurement of the current frame and move to next one " )
        print( " If you mistake, push a again and the data is revised." )
        
        i=0
        nselect=0
        display(openfile,1,zs+,zr+,z1=INDEF,z2=INDEF,fi+)
        npoint = 0

        while( fscan( imcur, x, y, wcs, command) != EOF)
        {
                key = substr(command,1,1)
                if( key == 'k'){
                     delete( tmpfile4,ver-,>&"dev$null" )
                     delete( tmpfile5,ver-,>&"dev$null" )
                     print(":",x,y," k", >> tmpfile4)
                     imexam(openfile,logfile=tmpfile5,keeplog+,graphcur-,imagecur=tmpfile4,graphic="stdgraph",use_dis+,>&"dev$null")
                     list5 = tmpfile5
	             while( fscan(list5,junk1,junk2,junk3,junk4,junk5,junk6,junk7) != EOF ){
                         if(junk1 != "#" ){
                            print(junk1," ",junk2," ",junk3," ",junk4," ",junk5," ",junk6," ",junk7)
                            print(junk1," ",junk2," ",junk3," ",junk4," ",junk5," ",junk6," ",junk7) | scanf("%*7s%d-%d%*1s center=%f peak=%f sigma=%f",tx1,tx2,y_pos,peakvalue,y_sigma) 
	                    x_pos=(tx1+tx2)/2
                            print("Peak position is ",x_pos,y_pos)
                            print("Sigma =",y_sigma)
                            print("Peak =",peakvalue)
                            npoint = 1
                         }
                     }

                }
                else if( key == 'q'){
                   if( npoint == 0){
                        print( "No measurement has been made !" )
                        beep
                   }
                   else
                     break
                }
                else{
                   beep
                }
        }

        delete( tmpfile4,ver-,>&"dev$null" )
        delete( tmpfile5,ver-,>&"dev$null" )
        print(":",x,y," k", >> tmpfile4)
        print(": naverage ",pixwid, >> tmpfile4)
        imexam(openfile,logfile=tmpfile5,keeplog+,graphcur-,imagecur=tmpfile4,graphic="stdgraph",use_dis+,>&"dev$null")

        delete( logfile,ver-,>&"dev$null" )
        imgets(openfile,"naxis1") 
        naxis1=int(imgets.value)
        imgets(openfile,"naxis2") 
        naxis2=int(imgets.value)
        print(naxis1,naxis2,>> logfile)
	x=64
        y=y_pos
        while(x<513)
        {
                delete( tmpfile4,ver-,>&"dev$null" )
                delete( tmpfile5,ver-,>&"dev$null" )

                print(":",x,y," k", >> tmpfile4)
                imexam(openfile1,logfile=tmpfile5,keeplog+,graphcur-,imagecur=tmpfile4,graphic="stdgraph",use_dis-,autoredraw-,>&"dev$null")
                list5 = tmpfile5
                     if( fscan( list5, junk2 ) == 1){
                        if( fscan(list5,junk1,junk2,junk3,junk4,junk5,junk6,junk7) == 7){ 
                            print(junk1," ",junk2," ",junk3," ",junk4," ",junk5," ",junk6," ",junk7) | scanf("%*7s%d-%d%*1s center=%f peak=%f sigma=%f",tx1,tx2,y_pos,peakvalue,y_sigma) 
                                print(x,y_pos,y_sigma,peakvalue,>> logfile)
                        }
                     }
                x=x+pixwid
#		y=y_pos
        }

	x=512
#        y=y_pos
        while(x<970)
        {
                delete( tmpfile4,ver-,>&"dev$null" )
                delete( tmpfile5,ver-,>&"dev$null" )

                print(":",x,y," k", >> tmpfile4)
                imexam(openfile2,logfile=tmpfile5,keeplog+,graphcur-,imagecur=tmpfile4,graphic="stdgraph",use_dis-,autoredraw-,>&"dev$null")
                list5 = tmpfile5
                     if( fscan( list5, junk2 ) == 1){
                        if( fscan(list5,junk1,junk2,junk3,junk4,junk5,junk6,junk7) == 7){ 
                            print(junk1," ",junk2," ",junk3," ",junk4," ",junk5," ",junk6," ",junk7) | scanf("%*7s%d-%d%*1s center=%f peak=%f sigma=%f",tx1,tx2,y_pos,peakvalue,y_sigma) 
                                print(x,y_pos,y_sigma,peakvalue,>> logfile)
                        }
                     }
                x=x+pixwid
#		y=y_pos
        }

finish:
        delete( tmpfile4,ver-,>&"dev$null" )
        delete( tmpfile5,ver-,>&"dev$null" )
        bye
end
